package provide Paved::Tree 1.1

##  pavetree.tcl
##
##	Paved-Tree : an extension of the BWidget-Tree widget.
##
##  Copyright (c) 2006 <Irrational Numbers> : <aburatti@libero.it> 
##
##  NOTE: package "snit" (v0.91 or later) is required.
##   It is freely downloadable from the Web:
##       http://www.wjduquette.com/snit
##
##  This program is free software; you can redistribute it and/or modify
##  it under the terms of the GNU General Public License as published by
##  the Free Software Foundation.
##
##  See the file "license" for information on usage and
##  redistribution of this program, and for a disclaimer of all warranties.
##

package require  snit

#
# How to use Paved::Tree:
#   Read "pavetree.txt" for detailed info.
#   Sample code in provided in "demo*.tcl".
#


package require snit
package require BWidget
package require Paved::canvas


snit::widgetadaptor Paved::TreeAdaptor {
    
    # pseudo-component (see the constructor)
   component internalCanvas
   
   delegate option -tile to internalCanvas
   delegate option -tileorigin to internalCanvas
   delegate option -bgzoom to internalCanvas
          
   delegate option *     to hull
   delegate method *     to hull

   constructor {args} {
      installhull $win
       # a BWidget-Tree uses a canvas sub-widget for drawing the tree.
       # This internal canvas is named ".c".
       # BWidget-Tree provides an undocumented (and steady) method
       #  for accessing this feature 
    
       # internalCanvas is 'pseudo' Snit component. 
       # Being already within $win, you shouldn't install it;
       #  just provide a reference          
      set internalCanvas [Tree::getcanvas $win]
      Paved::canvasAdaptor $internalCanvas
      $win configurelist $args
   }

}


namespace eval Paved { ; }

  # this command *creates* a *new* Paved::Tree widget
  # (in contrast with Paved::TreelAdaptor 
  #  that wraps a pre-existing Tree widget)
proc Paved::Tree {path args} {
   eval TreeAdaptor [::Tree $path] $args
   return $path
}



